import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:flutter_share/flutter_share.dart';
import 'package:insuideindoor/main/filter_data.dart';
// import 'package:mapbox_gl_example/http/services.dart';
import 'package:insuideindoor/main/loading.dart';
import 'package:insuideindoor/main/poiInfo.dart';
import 'package:insuideindoor/main/poi_model.dart';
import 'package:insuideindoor/main/services.dart';
import 'package:insuideindoor/main/splash.dart';
import 'package:insuideindoor/main/to_direction.dart';

import 'package:mapbox_gl/mapbox_gl.dart';
import 'package:shared_preferences/shared_preferences.dart';

// import 'package:mapbox_gl_example/models/poi_model.dart';

class MyHome extends StatefulWidget {
  final data;

  const MyHome({Key? key, required this.data}) : super(key: key);

  @override
  State<MyHome> createState() => _MyHomeState();
}

GetPoi? poiPoints;
int? loopCounter;
TextEditingController searchController = TextEditingController();
List<Datum> searchList = [];
List<Datum> dataPois = [];
List recentSearchName = [];
List recentSearchGeo = [];

class _MyHomeState extends State<MyHome> {
  // LatLng? latLngPresent = GetLatLngFromSP();
  double? userLat;
  double? userLong;

  late CameraPosition _initialCameraPosition;

  late MapboxMapController controller;
  bool isLoading = true;
  bool finalBool = true;
  bool finalBool2 = true;

  List<LatLng> poisList = [];
  List<String> poisName = [];
  List<String> poiImage = [];
  LatLng? currentLocationIA;
  bool t1 = false;
  LatLng? dynamicLatLng;
  String? kamalString;

  bool? isTerminal2Selected;

  // List<MapMarker> mapMarkerList = [];

  @override
  void initState() {
    super.initState();
    print("widget.data ${widget.data}");
    LatLng aaa = convertToLatLng();
    searchList.clear();
    setState(() {
      isLoading = true;
      finalBool = true;
      finalBool2 = true;
    });
    //LatLng(19.093099, 72.856952)

    fetchPois();
    sharedLatLng().then((value) {
      setState(() {
        _initialCameraPosition = CameraPosition(
            target: dynamicLatLng ?? LatLng(19.098519, 72.874318),
            zoom: 17,
            tilt: 30.0);
      });
    });
    sharedStyleString().then((value) {
      setState(() {
        kamalString = value;
        print("this is kamal string $kamalString");
        finalBool2 = false;
      });
    });
  }

  Future<LatLng> sharedLatLng() async {
    setState(() {
      isLoading = true;
    });
    final SharedPreferences sharedPreferences =
        await SharedPreferences.getInstance();
    bool myisTerminal2Selected =
        sharedPreferences.getBool("isTerminal2Selected") ?? true;
    double latt = sharedPreferences.getDouble('lat') ?? 19.098519;
    double longg = sharedPreferences.getDouble('long') ?? 72.874318;
    print("Final LatLng ${LatLng(latt, longg)}");
    setState(() {
      dynamicLatLng = LatLng(latt, longg);
      finalBool = false;
      isTerminal2Selected = myisTerminal2Selected;
    });
    return LatLng(latt, longg);
  }

  Future<String> sharedStyleString() async {
    setState(() {
      isLoading = true;
    });
    final SharedPreferences sharedPreferences =
        await SharedPreferences.getInstance();
    String styleStringMain = sharedPreferences.getString('styleString') ??
        'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx';

    return styleStringMain;
  }

  LatLng convertToLatLng() {
    String a = widget.data;
    List latlng = a.split(',');
    double _lat = double.parse(latlng[0]);
    double _lng = double.parse(latlng[1]);
    LatLng finalIALatLng = LatLng(_lat, _lng);
    return finalIALatLng;
  }

  void _onMapCreated(MapboxMapController mapboxMapController) {
    controller = mapboxMapController;
  }

  fetchPois() async {
    final SharedPreferences? sharedPreferences =
        await SharedPreferences.getInstance();

    String myTer = sharedPreferences?.getString('terminal') ?? "2";
    String myLev = sharedPreferences?.getString('level') ?? "4";

    setState(() {
      myTer = sharedPreferences?.getString('terminal') ?? "2";
      myLev = sharedPreferences?.getString('level') ?? "4";
    });
    poiPoints = await InternetService().getPOI().then((value) {
      loopCounter = value!.data!.length;
      poisList.clear();
      poisName.clear();
      poiImage.clear();

      if (loopCounter! > 0) {
        dataPois = value.data!;
        setState(() {});
      }

      for (int a = 1; a <= loopCounter!; a++) {
        if (value.data?[a - 1].terminal == myTer &&
            value.data?[a - 1].levelid == myLev) {
          poisList
              .add(LatLng(value.data![a - 1].lat!, value.data![a - 1].lng!));
          poisName.add(value.data?[a - 1].poiMultilingual!.en!.name ?? "Test");
          poiImage.add(value.data?[a - 1].subcategory.toString() ?? "EMPTY");
        }
      }

      return null;
    });
    setState(() {
      print("mai hu mounted $mounted");
      isLoading = false;
    });
  }

  tappedaFunction(Symbol symbol) {
    print("printSymbol $symbol");
    Fluttertoast.showToast(
      msg: 'Tapped on POI',
    );
  }

  void addSymbol(MapboxMapController mapBoxController) {
    //SHOWING CURRENT USER LOCATION ON MAP
    mapBoxController.addSymbol(
      const SymbolOptions(
        geometry: LatLng(19.098519, 72.874318),
        // geometry: convertToLatLng(),
        iconImage: "assets/symbols/Oval.png",
        iconSize: 50,
      ),
    );
    controller.onSymbolTapped.add((argument) {
      print("DATA FROM POI");
      print(argument.options.geometry.toString());
      print(argument.options.textField.toString());
      print(argument.options.iconImage.toString());

      showModalBottomSheet<void>(
        isDismissible: true,
        enableDrag: true,
        context: context,
        builder: (BuildContext context) {
          return PoiInfo(
            geo: argument.options.geometry.toString(),
            poiName: argument.options.textField.toString(),
            iconImage: argument.options.iconImage.toString(),
          );
        },
      );
    });

    List<LatLng> lineData = [
      const LatLng(19.097272693531593, 72.87464746738887),
      const LatLng(26.952111131978132, 75.72147354583491)
    ];
    List<LatLng> lineDataTest = [
      LatLng(72.874306, 19.099388),
      LatLng(72.87294, 19.099372),
      LatLng(72.872852, 19.099391),
      LatLng(72.872718, 19.09946),
      LatLng(72.872604, 19.099556),
      LatLng(72.872513, 19.099677),
      LatLng(72.872479, 19.099903),
      LatLng(72.87242, 19.100114),
      LatLng(72.872399, 19.100314),
      LatLng(72.872406, 19.100827),
      LatLng(72.872319, 19.101659),
      LatLng(72.872366, 19.101896),
      LatLng(72.872413, 19.102873),
      LatLng(72.872452, 19.103083),
      LatLng(72.872514, 19.103182),
      LatLng(72.872553, 19.103182),
      LatLng(72.872941, 19.103184),
      LatLng(72.873272, 19.103185),
      LatLng(72.874271, 19.103202),
      LatLng(72.874484, 19.103203),
      LatLng(72.874609, 19.103205),
      LatLng(72.875038, 19.103193),
      LatLng(72.875487, 19.103184),
      LatLng(72.876121, 19.103165),
      LatLng(72.876751, 19.103146),
      LatLng(72.876752, 19.103096),
      LatLng(72.876753, 19.103033),
      LatLng(72.876794, 19.101146),
      LatLng(72.876783, 19.101002),
      LatLng(72.876799, 19.100957),
      LatLng(72.876833, 19.100919),
      LatLng(72.87691, 19.100885),
      LatLng(72.877007, 19.100842),
      LatLng(72.877254, 19.10073),
      LatLng(72.877286, 19.100693),
      LatLng(72.877305, 19.100644),
      LatLng(72.877265, 19.100356),
      LatLng(72.877278, 19.100302),
      LatLng(72.877316, 19.100229),
      LatLng(72.877371, 19.100174),
      LatLng(72.87749, 19.100108),
      LatLng(72.877741, 19.10011),
      LatLng(72.878044, 19.099993),
      LatLng(72.877956, 19.099454),
      LatLng(72.877936, 19.099337),
      LatLng(72.877856, 19.099184),
      LatLng(72.876825, 19.097626),
      LatLng(72.876739, 19.097427),
      LatLng(72.876731, 19.097344),
      LatLng(72.876721, 19.097251),
      LatLng(72.876741, 19.097031),
      LatLng(72.876784, 19.096868),
      LatLng(72.876833, 19.096761),
      LatLng(72.876918, 19.096648),
      LatLng(72.878045, 19.095671),
      LatLng(72.878084, 19.095583),
      LatLng(72.878098, 19.095483),
      LatLng(72.878061, 19.095343),
      LatLng(72.877919, 19.095029),
      LatLng(72.877442, 19.094336),
      LatLng(72.877701, 19.094178),
      LatLng(72.878049, 19.093966),
      LatLng(72.878303, 19.09381),
      LatLng(72.87817, 19.093578),
      LatLng(72.878151, 19.093531),
      LatLng(72.878134, 19.09322),
      LatLng(72.878146, 19.093102),
      LatLng(72.878235, 19.092686),
      LatLng(72.878504, 19.091582),
      LatLng(72.878516, 19.091495),
      LatLng(72.878539, 19.091226),
      LatLng(72.878564, 19.091185),
      LatLng(72.878607, 19.09116),
      LatLng(72.878717, 19.091137),
      LatLng(72.879245, 19.09117),
      LatLng(72.879372, 19.091198),
      LatLng(72.87958, 19.091259),
      LatLng(72.88019, 19.091329),
      LatLng(72.880388, 19.091327),
      LatLng(72.880448, 19.09134),
      LatLng(72.880545, 19.091377),
      LatLng(72.880605, 19.09139),
      LatLng(72.881114, 19.091366),
      LatLng(72.881187, 19.091339),
      LatLng(72.881229, 19.09131),
      LatLng(72.881271, 19.091264),
      LatLng(72.881297, 19.091185),
      LatLng(72.881304, 19.090386),
      LatLng(72.881294, 19.089889),
      LatLng(72.881312, 19.089824),
      LatLng(72.881342, 19.089769),
      LatLng(72.881386, 19.089745),
      LatLng(72.881446, 19.089661),
      LatLng(72.881477, 19.089625),
      LatLng(72.881489, 19.089575),
      LatLng(72.881428, 19.089389),
      LatLng(72.881396, 19.089274),
      LatLng(72.881388, 19.089085),
      LatLng(72.881216, 19.088648),
      LatLng(72.88117, 19.088507),
      LatLng(72.881143, 19.088396),
      LatLng(72.881089, 19.088056),
      LatLng(72.881062, 19.08801),
      LatLng(72.881013, 19.08796),
      LatLng(72.880943, 19.087929),
      LatLng(72.880218, 19.087865),
      LatLng(72.878706, 19.08784),
      LatLng(72.878643, 19.087829),
      LatLng(72.878587, 19.087796),
      LatLng(72.878547, 19.087762),
      LatLng(72.878514, 19.087698),
      LatLng(72.878471, 19.087528),
      LatLng(72.878448, 19.087468),
      LatLng(72.878392, 19.087404),
      LatLng(72.878303, 19.087351),
      LatLng(72.878223, 19.087325),
      LatLng(72.878152, 19.087304),
      LatLng(72.877068, 19.087212),
      LatLng(72.876923, 19.087209),
      LatLng(72.876835, 19.087222),
      LatLng(72.876751, 19.087236),
      LatLng(72.876681, 19.087234),
      LatLng(72.876619, 19.087208),
      LatLng(72.876569, 19.087172),
      LatLng(72.876546, 19.087119),
      LatLng(72.876471, 19.086608),
      LatLng(72.876451, 19.086539),
      LatLng(72.876423, 19.086477),
      LatLng(72.876277, 19.086267),
      LatLng(72.87626, 19.086232),
      LatLng(72.876248, 19.086203),
      LatLng(72.876219, 19.086061),
      LatLng(72.876209, 19.086022),
      LatLng(72.876192, 19.085994),
      LatLng(72.875934, 19.085762),
      LatLng(72.875881, 19.085735),
      LatLng(72.875805, 19.085731),
      LatLng(72.875234, 19.085822),
      LatLng(72.875163, 19.085827),
      LatLng(72.875105, 19.085818),
      LatLng(72.875057, 19.08578),
      LatLng(72.87503, 19.085599),
      LatLng(72.875039, 19.085519),
      LatLng(72.875596, 19.084466),
      LatLng(72.875627, 19.084428),
      LatLng(72.875686, 19.084392),
      LatLng(72.875827, 19.08434),
      LatLng(72.875915, 19.084304),
      LatLng(72.875971, 19.084262),
      LatLng(72.87607, 19.08415),
      LatLng(72.876143, 19.084029),
      LatLng(72.876204, 19.083897),
      LatLng(72.876248, 19.083831),
      LatLng(72.87685, 19.083122),
      LatLng(72.876911, 19.083039),
      LatLng(72.876966, 19.082927),
      LatLng(72.877002, 19.082785),
      LatLng(72.877038, 19.082655),
      LatLng(72.877367, 19.081835),
      LatLng(72.877752, 19.081078),
      LatLng(72.877823, 19.080909),
      LatLng(72.87786, 19.080765),
      LatLng(72.877894, 19.080666),
      LatLng(72.877125, 19.081371)
    ];
    mapBoxController.addLine(
      LineOptions(
        geometry: lineData,
        lineColor: "#ff0505",
        lineBlur: 0.5,
        lineWidth: 5.0,
        lineOpacity: 1.0,
      ),
    );

    for (int a = 0; a < loopCounter!; a++) {
      String iconReturn() {
        if (poiImage[a] == "restaurant" ||
            poiImage[a] == "bar" ||
            poiImage[a] == "cafe" ||
            poiImage[a] == "fast food") {
          return "assets/symbols/restro.png";
        } else if (poiImage[a] == "clothing") {
          return "assets/symbols/clothing.png";
        } else if (poiImage[a] == "bar") {
          return "assets/symbols/restro.png";
        } else if (poiImage[a] == "travel & books") {
          return "assets/symbols/travelbook.png";
        } else if (poiImage[a] == "electronics") {
          //to be updated
          return "assets/symbols/travelbook.png";
        } else if (poiImage[a] == "gifts & toys") {
          return "assets/symbols/gift.png";
        } else if (poiImage[a] == "atm") {
          return "assets/symbols/atm.png";
        } else if (poiImage[a] == "Currency exchange") {
          return "assets/symbols/currencyexchange.png";
        } else if (poiImage[a] == "Lounge") {
          return "assets/symbols/lounge.png";
        } else if (poiImage[a] == "Telephone") {
          return "assets/symbols/telephone.png";
        } else if (poiImage[a] == "Children's play area") {
          return "assets/symbols/playarea.png";
        } else if (poiImage[a] == "Ticket counter") {
          return "assets/symbols/ticketcounter.png";
        } else if (poiImage[a] == "Tourism") {
          return "assets/symbols/tourism.png";
        } else if (poiImage[a] == "Post office") {
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "Baby changing room ") {
          return "assets/symbols/babychange.png";
        } else if (poiImage[a] == "Baggage claim") {
          return "assets/symbols/baggageclaim.png";
        } else if (poiImage[a] == "bus") {
          return "assets/symbols/bus.png";
        } else if (poiImage[a] == "car") {
          return "assets/symbols/car.png";
        } else if (poiImage[a] == "Check-in counters") {
          return "assets/symbols/checkin.png";
        } else if (poiImage[a] == "Customs") {
          return "assets/symbols/customs.png";
        } else if (poiImage[a] == "Escalator") {
          return "assets/symbols/escalator.png";
        } else if (poiImage[a] == "Exit") {
          return "assets/symbols/exit.png";
        } else if (poiImage[a] == "Gates") {
          //TO BE CHANGED
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "FIDS") {
          //TO BE CHANGED
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "Lift") {
          return "assets/symbols/lift.png";
        } else if (poiImage[a] == "Lost and found") {
          return "assets/symbols/lostandfound.png";
        } else if (poiImage[a] == "Metro") {
          return "assets/symbols/metro.png";
        } else if (poiImage[a] == "Passport control") {
          return "assets/symbols/passport.png";
        } else if (poiImage[a] == "Charging") {
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "Prayer room") {
          return "assets/symbols/prayer.png";
        } else if (poiImage[a] == "security screening") {
          return "assets/symbols/security.png";
        } else if (poiImage[a] == "smoking room") {
          return "assets/symbols/smoking.png";
        } else if (poiImage[a] == "staircase") {
          return "assets/symbols/stairs.png";
        } else if (poiImage[a] == "toilet") {
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "train") {
          return "assets/symbols/train.png";
        } else if (poiImage[a] == "transit") {
          return "assets/symbols/transit.png";
        } else if (poiImage[a] == "drinking water") {
          //TO BE CHANGEd
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "emergency exit") {
          return "assets/symbols/exit.png";
        } else if (poiImage[a] == "medical") {
          return "assets/symbols/medical.png";
        } else if (poiImage[a] == "female toilet") {
          return "assets/symbols/femaletoilet.png";
        } else if (poiImage[a] == "male toilet") {
          return "assets/symbols/toilet.png";
        } else if (poiImage[a] == "disabled toilet") {
          return "assets/symbols/disabled.png";
        } else if (poiImage[a] == "Help desk") {
          return "assets/symbols/helpdesk.png";
        } else {
          return "assets/symbols/helpdesk.png";
          // return "assets/symbols/neww.png";
        }
      }

      mapBoxController.addSymbol(
        SymbolOptions(
            geometry: poisList[a],
            iconImage: iconReturn(),
            iconSize: 2.5,
            textField: poisName[a],
            textSize: 15,
            iconOffset: const Offset(0, -10)),
      );
    }
    mapBoxController.onSymbolTapped.add(((argument) {
      print("aaunga $argument");
    }));

    mapBoxController.onSymbolTapped.add(tappedaFunction);

    mapBoxController.onSymbolTapped.add(tappedaFunction);
  }

  @override
  Widget build(BuildContext context) {
    const Channel = MethodChannel("com.mapbox.mapboxglexample");
    const platform = MethodChannel("com.mapbox.mapboxglexample");

    platform.setMethodCallHandler((call) async {
      print("init state setMethodCallHandler ${call.arguments}");
      setState(() {
        // _initialCameraPosition =
        //     CameraPosition(target: convertToLatLng(), zoom: 17, tilt: 30.0);
      });
      ScaffoldMessenger.of(context).showSnackBar(
        SnackBar(
          content: Text(convertToLatLng().toString()),
        ),
      );
    });
    // setState(() {
    //   _initialCameraPosition =
    //       CameraPosition(target: convertToLatLng(), zoom: 17, tilt: 30.0);
    //   ScaffoldMessenger.of(context).showSnackBar(
    //     SnackBar(
    //       content: Text(widget.data),
    //     ),
    //   );
    // });
    double myHeight = MediaQuery.of(context).size.height / 3.8;
    double myBigHeight = MediaQuery.of(context).size.height - myHeight - 100;
    double width = MediaQuery.of(context).size.width;
    double height = MediaQuery.of(context).size.height;
    double btnPadding = 10.0;
    double btnSize = 25.0;
    double fontSize = 16.0;
    Future<void> shareRestro(String title, String location) async {
      await FlutterShare.share(
        title: title,
        text: location,
      );
    }

    return Scaffold(
      // floatingActionButton: FloatingActionButton(
      //   onPressed: () {
      //     Navigator.push(
      //       context,
      //       MaterialPageRoute(builder: (context) => const ToDirection()),
      //     );
      //   },
      //   child: Image.asset("assets/symbols/Oval.png"),
      // ),
      body: finalBool && finalBool2
          ? const Center(child: CircularProgressIndicator())
          : SafeArea(
              child: Container(
              width: width,
              height: height,
              child: Stack(
                children: [
                  SizedBox(
                    child: isLoading
                        ? Center(
                            child: Column(
                              mainAxisAlignment: MainAxisAlignment.center,
                              children: [
                                CircularProgressIndicator(),
                                SizedBox(
                                  height: 20,
                                ),
                                Text("Loading POI's & IA Location")
                              ],
                            ),
                          )
                        : Stack(
                            children: [
                              SizedBox(
                                height: myBigHeight,
                                child: Stack(
                                  alignment: Alignment.bottomCenter,
                                  children: [
                                    Container(
                                      height: myBigHeight,
                                      child: MapboxMap(
                                        tiltGesturesEnabled: true,
                                        accessToken:
                                            "sk.eyJ1IjoibWVycmlsbGdvbnNhbHZlcyIsImEiOiJja2l6eno3ZWk0ZnYxMnNsYng5azdxdjBiIn0.fkx2_7LZ7uq80mHYCuh46w",
                                        initialCameraPosition:
                                            _initialCameraPosition,
                                        onMapCreated: _onMapCreated,
                                        trackCameraPosition: true,
                                        onCameraTrackingChanged: (mode) {
                                          // print("mode.name ${mode}");
                                          // print("mode.name ${mode.name}");
                                        },

                                        onStyleLoadedCallback: () =>
                                            addSymbol(controller),
                                        // myLocationEnabled: true,
                                        myLocationTrackingMode:
                                            MyLocationTrackingMode.TrackingGPS,
                                        // minMaxZoomPreference:
                                        //     const MinMaxZoomPreference(14, 17),
                                        // annotationOrder: [
                                        //   AnnotationType.symbol
                                        // ],
                                        styleString: kamalString,
                                      ),
                                    ),
                                    Container(
                                      margin: const EdgeInsets.only(
                                          left: 20, right: 20),
                                      padding:
                                          const EdgeInsets.only(bottom: 10),
                                      child: Row(
                                        crossAxisAlignment:
                                            CrossAxisAlignment.end,
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          GestureDetector(
                                            //USER LOCATION
                                            onTap: () {
                                              controller.animateCamera(
                                                  CameraUpdate.newCameraPosition(
                                                      const CameraPosition(
                                                          target: LatLng(
                                                              19.098519,
                                                              72.874318),
                                                          zoom: 17,
                                                          tilt: 30.0)
                                                      // CameraPosition(
                                                      //     target:
                                                      //         convertToLatLng())
                                                      ));
                                            },
                                            child: Container(
                                              padding:
                                                  EdgeInsets.all(btnPadding),
                                              decoration: BoxDecoration(
                                                  color: Colors.white,
                                                  borderRadius:
                                                      BorderRadius.circular(
                                                          10)),
                                              child: Image.asset(
                                                "assets/images/location.png",
                                                width: btnSize,
                                                height: btnSize,
                                              ),
                                            ),
                                          ),
                                          GestureDetector(
                                            onTap: () {
                                              print("TAPPED ON SHARE");
                                              shareRestro("Insuide Maps",
                                                  "We'll share your location here");
                                            },
                                            child: Column(
                                              mainAxisSize: MainAxisSize.min,
                                              children: [
                                                Container(
                                                  padding: EdgeInsets.all(
                                                      btnPadding),
                                                  decoration: BoxDecoration(
                                                      color: Colors.white,
                                                      borderRadius:
                                                          BorderRadius.only(
                                                              topLeft: Radius
                                                                  .circular(7),
                                                              topRight: Radius
                                                                  .circular(
                                                                      7))),
                                                  child: Image.asset(
                                                    "assets/images/navigate.png",
                                                    width: btnSize,
                                                    height: btnSize,
                                                  ),
                                                ),
                                                SizedBox(
                                                  height: 1,
                                                ),
                                                GestureDetector(
                                                  onTap: () {
                                                    showModalBottomSheet<void>(
                                                      context: context,
                                                      builder: (BuildContext
                                                          context) {
                                                        return Container(
                                                          decoration: const BoxDecoration(
                                                              color:
                                                                  Colors.white,
                                                              borderRadius: BorderRadius.only(
                                                                  topLeft: Radius
                                                                      .circular(
                                                                          50),
                                                                  topRight: Radius
                                                                      .circular(
                                                                          50))),
                                                          child: Padding(
                                                            padding:
                                                                const EdgeInsets
                                                                    .all(10.0),
                                                            child:
                                                                SingleChildScrollView(
                                                              child: Column(
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: [
                                                                  Align(
                                                                    alignment:
                                                                        Alignment
                                                                            .center,
                                                                    child:
                                                                        Container(
                                                                      width:
                                                                          width *
                                                                              0.2,
                                                                      height: 5,
                                                                      decoration: BoxDecoration(
                                                                          color: Color(
                                                                              0xffEAEBED),
                                                                          borderRadius:
                                                                              BorderRadius.circular(10.0)),
                                                                    ),
                                                                  ),
                                                                  GestureDetector(
                                                                    onTap: () {
                                                                      Navigator.pop(
                                                                          context);
                                                                    },
                                                                    child: Icon(
                                                                        Icons
                                                                            .close),
                                                                  ),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () async {
                                                                        final SharedPreferences
                                                                            sharedPreferences =
                                                                            await SharedPreferences.getInstance();
                                                                        sharedPreferences.setDouble(
                                                                            'lat',
                                                                            19.092067);
                                                                        sharedPreferences.setDouble(
                                                                            'long',
                                                                            72.853808);
                                                                        sharedPreferences.setString(
                                                                            'styleString',
                                                                            'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw');
                                                                        sharedPreferences.setString(
                                                                            "level",
                                                                            "2");
                                                                        sharedPreferences.setString(
                                                                            "terminal",
                                                                            "1");

                                                                        Navigator
                                                                            .push(
                                                                          context,
                                                                          MaterialPageRoute(
                                                                              builder: (context) => const Loading()),
                                                                        );

                                                                        // controller
                                                                        //     .dispose();

                                                                        if (isTerminal2Selected ??
                                                                            true) {
                                                                          setState(
                                                                              () {
                                                                            sharedPreferences.setBool('isTerminal2Selected',
                                                                                false);
                                                                          });
                                                                        } else {
                                                                          setState(
                                                                              () {
                                                                            sharedPreferences.setBool('isTerminal2Selected',
                                                                                true);
                                                                          });
                                                                        }
                                                                      },
                                                                      child:
                                                                          Row(
                                                                        mainAxisAlignment:
                                                                            MainAxisAlignment.spaceBetween,
                                                                        children: [
                                                                          Text(
                                                                              "Terminal 1",
                                                                              style: !isTerminal2Selected! ? const TextStyle(color: Colors.black, fontWeight: FontWeight.bold) : TextStyle(color: Colors.black)),
                                                                          !isTerminal2Selected!
                                                                              ? const Icon(
                                                                                  Icons.check,
                                                                                  color: Colors.black,
                                                                                )
                                                                              : Container()
                                                                        ],
                                                                      )),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () async {
                                                                        final SharedPreferences
                                                                            sharedPreferences =
                                                                            await SharedPreferences.getInstance();
                                                                        sharedPreferences.setDouble(
                                                                            'lat',
                                                                            19.098519);
                                                                        sharedPreferences.setDouble(
                                                                            'long',
                                                                            72.874318);
                                                                        sharedPreferences.setString(
                                                                            'styleString',
                                                                            'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx');
                                                                        sharedPreferences.setString(
                                                                            "level",
                                                                            "4");
                                                                        sharedPreferences.setString(
                                                                            "terminal",
                                                                            "2");
                                                                        Navigator
                                                                            .push(
                                                                          context,
                                                                          MaterialPageRoute(
                                                                              builder: (context) => const Loading()),
                                                                        );
                                                                        // controller
                                                                        //     .dispose();

                                                                        if (isTerminal2Selected ??
                                                                            true) {
                                                                          await sharedPreferences.setBool(
                                                                              "isTerminal2Selected",
                                                                              false);
                                                                          setState(
                                                                              () {});
                                                                        } else {
                                                                          await sharedPreferences.setBool(
                                                                              "isTerminal2Selected",
                                                                              true);
                                                                          setState(
                                                                              () {});
                                                                        }
                                                                      },
                                                                      child:
                                                                          Row(
                                                                        mainAxisAlignment:
                                                                            MainAxisAlignment.spaceBetween,
                                                                        children: [
                                                                          Text(
                                                                              "Terminal 2",
                                                                              style: isTerminal2Selected ?? true ? const TextStyle(color: Colors.black, fontWeight: FontWeight.bold) : const TextStyle(color: Colors.black)),
                                                                          isTerminal2Selected!
                                                                              ? const Icon(
                                                                                  Icons.check,
                                                                                  color: Colors.black,
                                                                                )
                                                                              : Container()
                                                                        ],
                                                                      )),
                                                                ],
                                                              ),
                                                            ),
                                                          ),
                                                        );
                                                      },
                                                    );
                                                  },
                                                  child: Container(
                                                    padding: EdgeInsets.all(
                                                        btnPadding),
                                                    decoration: BoxDecoration(
                                                        color: Colors.white,
                                                        borderRadius:
                                                            BorderRadius.only(
                                                                bottomLeft: Radius
                                                                    .circular(
                                                                        7),
                                                                bottomRight:
                                                                    Radius
                                                                        .circular(
                                                                            7))),
                                                    child: Image.asset(
                                                      "assets/images/terminal.png",
                                                      width: btnSize,
                                                      height: btnSize,
                                                    ),
                                                  ),
                                                ),
                                                SizedBox(
                                                  height: 1,
                                                ),
                                                GestureDetector(
                                                  onTap: () {
                                                    showModalBottomSheet<void>(
                                                      context: context,
                                                      builder: (BuildContext
                                                          context) {
                                                        return Container(
                                                          decoration: const BoxDecoration(
                                                              color:
                                                                  Colors.white,
                                                              borderRadius: BorderRadius.only(
                                                                  topLeft: Radius
                                                                      .circular(
                                                                          50),
                                                                  topRight: Radius
                                                                      .circular(
                                                                          50))),
                                                          child: Padding(
                                                            padding:
                                                                const EdgeInsets
                                                                    .all(10.0),
                                                            child:
                                                                SingleChildScrollView(
                                                              child: Column(
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: [
                                                                  TextButton(
                                                                      onPressed:
                                                                          () {
                                                                        Navigator.pop(
                                                                            context);
                                                                      },
                                                                      child: Text(
                                                                          "Terminal 1")),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () {
                                                                        Navigator.pop(
                                                                            context);
                                                                        // _body(
                                                                        //     t2l1);
                                                                      },
                                                                      child: Text(
                                                                          "Terminal 2")),
                                                                ],
                                                              ),
                                                            ),
                                                          ),
                                                        );
                                                      },
                                                    );
                                                  },
                                                  child: GestureDetector(
                                                    onTap: () {
                                                      showModalBottomSheet<
                                                          void>(
                                                        context: context,
                                                        builder: (BuildContext
                                                            context) {
                                                          return Container(
                                                            decoration: const BoxDecoration(
                                                                color: Colors
                                                                    .white,
                                                                borderRadius: BorderRadius.only(
                                                                    topLeft: Radius
                                                                        .circular(
                                                                            50),
                                                                    topRight: Radius
                                                                        .circular(
                                                                            50))),
                                                            child: Padding(
                                                              padding:
                                                                  const EdgeInsets
                                                                          .all(
                                                                      10.0),
                                                              child:
                                                                  SingleChildScrollView(
                                                                child: Column(
                                                                  crossAxisAlignment:
                                                                      CrossAxisAlignment
                                                                          .start,
                                                                  children: [
                                                                    Align(
                                                                      alignment:
                                                                          Alignment
                                                                              .center,
                                                                      child:
                                                                          Container(
                                                                        width: width *
                                                                            0.2,
                                                                        height:
                                                                            5,
                                                                        decoration: BoxDecoration(
                                                                            color:
                                                                                Color(0xffEAEBED),
                                                                            borderRadius: BorderRadius.circular(10.0)),
                                                                      ),
                                                                    ),
                                                                    GestureDetector(
                                                                      onTap:
                                                                          () {
                                                                        Navigator.pop(
                                                                            context);
                                                                      },
                                                                      child: Icon(
                                                                          Icons
                                                                              .close),
                                                                    ),
                                                                    Visibility(
                                                                      visible:
                                                                          !isTerminal2Selected!,
                                                                      child: TextButton(
                                                                          onPressed: () async {
                                                                            final SharedPreferences
                                                                                sharedPreferences =
                                                                                await SharedPreferences.getInstance();
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.093099);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.856952);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234');
                                                                            sharedPreferences.setString("level",
                                                                                "0");
                                                                            sharedPreferences.setString("terminal",
                                                                                "1");
                                                                            sharedPreferences.setBool("level0active",
                                                                                true);
                                                                            sharedPreferences.setBool("level1active",
                                                                                false);
                                                                            sharedPreferences.setBool("level2active",
                                                                                false);
                                                                            sharedPreferences.setBool("level3active",
                                                                                false);
                                                                            sharedPreferences.setBool("level4active",
                                                                                false);
                                                                            Navigator.pushReplacement(
                                                                              context,
                                                                              MaterialPageRoute(builder: (context) => const Loading()),
                                                                            );

                                                                            controller.dispose();
                                                                          },
                                                                          child: Row(
                                                                            mainAxisAlignment:
                                                                                MainAxisAlignment.spaceBetween,
                                                                            children: [
                                                                              const Text(
                                                                                "Level 0",
                                                                                style: TextStyle(color: Colors.black),
                                                                              ),
                                                                              sharedPreferences.getBool("level0active") ?? false
                                                                                  ? const Icon(
                                                                                      Icons.check,
                                                                                      color: Colors.black,
                                                                                    )
                                                                                  : Container()
                                                                            ],
                                                                          )),
                                                                    ),
                                                                    TextButton(
                                                                        onPressed:
                                                                            () async {
                                                                          final SharedPreferences
                                                                              sharedPreferences =
                                                                              await SharedPreferences.getInstance();
                                                                          bool
                                                                              _myCheckBool =
                                                                              sharedPreferences.getBool("isTerminal2Selected") ?? true;
                                                                          if (_myCheckBool) {
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.099474);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.874330);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5ez2e9l000j14r0y08curhk');

                                                                            if (isTerminal2Selected!) {
                                                                              sharedPreferences.setString("level", "1");
                                                                              sharedPreferences.setString("terminal", "2");
                                                                            } else {
                                                                              sharedPreferences.setString("level", "1");
                                                                              sharedPreferences.setString("terminal", "1");
                                                                            }

                                                                            controller.dispose();
                                                                          } else {
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.092141);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.855159);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5ez2lht002214s0ow0ghr8z');
                                                                          }
                                                                          Navigator
                                                                              .push(
                                                                            context,
                                                                            MaterialPageRoute(builder: (context) => const Loading()),
                                                                          );
                                                                          sharedPreferences.setBool(
                                                                              "level0active",
                                                                              false);
                                                                          sharedPreferences.setBool(
                                                                              "level1active",
                                                                              true);
                                                                          sharedPreferences.setBool(
                                                                              "level2active",
                                                                              false);
                                                                          sharedPreferences.setBool(
                                                                              "level3active",
                                                                              false);
                                                                          sharedPreferences.setBool(
                                                                              "level4active",
                                                                              false);
                                                                          print(
                                                                              "TAPPED IN LEVEL 1");
                                                                        },
                                                                        child:
                                                                            Row(
                                                                          mainAxisAlignment:
                                                                              MainAxisAlignment.spaceBetween,
                                                                          children: [
                                                                            const Text(
                                                                              "Level 1",
                                                                              style: TextStyle(color: Colors.black),
                                                                            ),
                                                                            sharedPreferences.getBool("level1active") ?? false
                                                                                ? const Icon(
                                                                                    Icons.check,
                                                                                    color: Colors.black,
                                                                                  )
                                                                                : Container()
                                                                          ],
                                                                        )),
                                                                    TextButton(
                                                                        onPressed:
                                                                            () async {
                                                                          final SharedPreferences
                                                                              sharedPreferences =
                                                                              await SharedPreferences.getInstance();
                                                                          bool
                                                                              myCheckBool =
                                                                              sharedPreferences.getBool("isTerminal2Selected") ?? true;
                                                                          if (myCheckBool) {
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.098588);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.874341);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5ez205n002h14pvay28t8iz');
                                                                            Navigator.pushReplacement(
                                                                              context,
                                                                              MaterialPageRoute(builder: (context) => const Loading()),
                                                                            );
                                                                            controller.dispose();
                                                                          } else {
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.092067);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.853808);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw');

                                                                            if (isTerminal2Selected!) {
                                                                              sharedPreferences.setString("level", "2");
                                                                              sharedPreferences.setString("terminal", "2");
                                                                            } else {
                                                                              sharedPreferences.setString("level", "2");
                                                                              sharedPreferences.setString("terminal", "1");
                                                                            }

                                                                            Navigator.pushReplacement(
                                                                              context,
                                                                              MaterialPageRoute(builder: (context) => const Loading()),
                                                                            );
                                                                            controller.dispose();
                                                                          }
                                                                          sharedPreferences.setBool(
                                                                              "level0active",
                                                                              false);
                                                                          sharedPreferences.setBool(
                                                                              "level1active",
                                                                              false);
                                                                          sharedPreferences.setBool(
                                                                              "level2active",
                                                                              true);
                                                                          sharedPreferences.setBool(
                                                                              "level3active",
                                                                              false);
                                                                          sharedPreferences.setBool(
                                                                              "level4active",
                                                                              false);
                                                                          // Navigator.pop(
                                                                          //     context);
                                                                          print(
                                                                              "TAPPED IN LEVEL 2");
                                                                        },
                                                                        child:
                                                                            Row(
                                                                          mainAxisAlignment:
                                                                              MainAxisAlignment.spaceBetween,
                                                                          children: [
                                                                            const Text(
                                                                              "Level 2",
                                                                              style: TextStyle(color: Colors.black),
                                                                            ),
                                                                            sharedPreferences.getBool("level2active") ?? false
                                                                                ? const Icon(
                                                                                    Icons.check,
                                                                                    color: Colors.black,
                                                                                  )
                                                                                : Container()
                                                                          ],
                                                                        )),
                                                                    Visibility(
                                                                      visible:
                                                                          isTerminal2Selected!,
                                                                      child: TextButton(
                                                                          onPressed: () async {
                                                                            final SharedPreferences
                                                                                sharedPreferences =
                                                                                await SharedPreferences.getInstance();
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.096827);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.874386);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5c9c84e006o14nu2a8sny58');
                                                                            sharedPreferences.setString("level",
                                                                                "3");
                                                                            sharedPreferences.setString("terminal",
                                                                                "2");
                                                                            Navigator.pushReplacement(
                                                                              context,
                                                                              MaterialPageRoute(builder: (context) => const Loading()),
                                                                            );
                                                                            sharedPreferences.setBool("level0active",
                                                                                false);
                                                                            sharedPreferences.setBool("level1active",
                                                                                false);
                                                                            sharedPreferences.setBool("level2active",
                                                                                false);
                                                                            sharedPreferences.setBool("level3active",
                                                                                true);
                                                                            sharedPreferences.setBool("level4active",
                                                                                false);
                                                                            controller.dispose();
                                                                          },
                                                                          child: Row(
                                                                            mainAxisAlignment:
                                                                                MainAxisAlignment.spaceBetween,
                                                                            children: [
                                                                              const Text(
                                                                                "Level 3",
                                                                                style: TextStyle(color: Colors.black),
                                                                              ),
                                                                              sharedPreferences.getBool("level3active") ?? false
                                                                                  ? const Icon(
                                                                                      Icons.check,
                                                                                      color: Colors.black,
                                                                                    )
                                                                                  : Container()
                                                                            ],
                                                                          )),
                                                                    ),
                                                                    Visibility(
                                                                      visible:
                                                                          isTerminal2Selected!,
                                                                      child: TextButton(
                                                                          onPressed: () async {
                                                                            final SharedPreferences
                                                                                sharedPreferences =
                                                                                await SharedPreferences.getInstance();
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.098519);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.874318);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx');
                                                                            sharedPreferences.setString("level",
                                                                                "4");
                                                                            sharedPreferences.setString("terminal",
                                                                                "2");
                                                                            sharedPreferences.setBool("level0active",
                                                                                false);
                                                                            sharedPreferences.setBool("level1active",
                                                                                false);
                                                                            sharedPreferences.setBool("level2active",
                                                                                false);
                                                                            sharedPreferences.setBool("level3active",
                                                                                false);
                                                                            sharedPreferences.setBool("level4active",
                                                                                true);

                                                                            Navigator.pushReplacement(
                                                                              context,
                                                                              MaterialPageRoute(builder: (context) => const Loading()),
                                                                            );
                                                                            controller.dispose();
                                                                          },
                                                                          child: Row(
                                                                            mainAxisAlignment:
                                                                                MainAxisAlignment.spaceBetween,
                                                                            children: [
                                                                              const Text(
                                                                                "Level 4",
                                                                                style: TextStyle(color: Colors.black),
                                                                              ),
                                                                              sharedPreferences.getBool("level4active") ?? true
                                                                                  ? const Icon(
                                                                                      Icons.check,
                                                                                      color: Colors.black,
                                                                                    )
                                                                                  : Container()
                                                                            ],
                                                                          )),
                                                                    ),
                                                                  ],
                                                                ),
                                                              ),
                                                            ),
                                                          );
                                                        },
                                                      );
                                                    },
                                                    child: Container(
                                                      padding: EdgeInsets.all(
                                                          btnPadding),
                                                      decoration: BoxDecoration(
                                                          color: Colors.white,
                                                          borderRadius:
                                                              BorderRadius.only(
                                                                  topLeft: Radius
                                                                      .circular(
                                                                          7),
                                                                  topRight: Radius
                                                                      .circular(
                                                                          7))),
                                                      child: Image.asset(
                                                        "assets/images/layers.png",
                                                        width: btnSize,
                                                        height: btnSize,
                                                      ),
                                                    ),
                                                  ),
                                                ),
                                              ],
                                            ),
                                          ),
                                        ],
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                              DraggableScrollableSheet(
                                  initialChildSize: 0.387,
                                  minChildSize: 0.387,
                                  maxChildSize: 1,
                                  snap: true,
                                  snapSizes: const [0.387, 1],
                                  builder: (BuildContext context,
                                      scrollSheetController) {
                                    return Container(
                                        decoration: const BoxDecoration(
                                            color: Colors.white,
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(16.0))),
                                        child: ListView.builder(
                                            padding: EdgeInsets.zero,
                                            physics:
                                                const ClampingScrollPhysics(),
                                            controller: scrollSheetController,
                                            itemCount: 1,
                                            itemBuilder: (BuildContext context,
                                                int index) {
                                              return Column(
                                                children: [
                                                  const SizedBox(height: 8),
                                                  Container(
                                                    width: width * 0.2,
                                                    height: 5,
                                                    decoration: BoxDecoration(
                                                        color:
                                                            Color(0xffEAEBED),
                                                        borderRadius:
                                                            BorderRadius
                                                                .circular(
                                                                    10.0)),
                                                  ),
                                                  const SizedBox(height: 15),
                                                  Container(
                                                    margin: const EdgeInsets
                                                            .symmetric(
                                                        horizontal: 20),
                                                    padding: const EdgeInsets
                                                        .symmetric(vertical: 0),
                                                    decoration: BoxDecoration(
                                                        color:
                                                            Color(0xffEAEBED),
                                                        borderRadius:
                                                            BorderRadius
                                                                .circular(40)),
                                                    child: TextFormField(
                                                      scrollPadding:
                                                          EdgeInsets.zero,
                                                      decoration:
                                                          InputDecoration(
                                                        // fillColor: Color(0xffEAEBED),
                                                        isDense: true,
                                                        contentPadding:
                                                            const EdgeInsets
                                                                .all(0.0),
                                                        prefixIcon: Icon(
                                                            Icons.search,
                                                            size: btnSize,
                                                            color: Color(
                                                                0xFF555555)),
                                                        suffixIcon:
                                                            GestureDetector(
                                                          onTap: () {
                                                            Navigator.push(
                                                              context,
                                                              MaterialPageRoute(
                                                                  builder:
                                                                      (context) =>
                                                                          const ToDirection()),
                                                            );
                                                          },
                                                          child: Icon(
                                                            Icons.directions,
                                                            size: btnSize,
                                                            color: Color(
                                                                0xFF555555),
                                                          ),
                                                        ),
                                                        hintText: "Search",
                                                        hintStyle:
                                                            const TextStyle(
                                                                fontWeight:
                                                                    FontWeight
                                                                        .bold,
                                                                fontSize: 15),
                                                        border: OutlineInputBorder(
                                                            borderRadius:
                                                                BorderRadius
                                                                    .circular(
                                                                        40),
                                                            borderSide: BorderSide(
                                                                color: Color(
                                                                    0xffEAEBED))),
                                                        disabledBorder: OutlineInputBorder(
                                                            borderRadius:
                                                                BorderRadius
                                                                    .circular(
                                                                        40),
                                                            borderSide: BorderSide(
                                                                color: Color(
                                                                    0xffEAEBED))),
                                                        enabledBorder: OutlineInputBorder(
                                                            borderRadius:
                                                                BorderRadius
                                                                    .circular(
                                                                        40),
                                                            borderSide: BorderSide(
                                                                color: Color(
                                                                    0xffEAEBED))),
                                                        focusedBorder: OutlineInputBorder(
                                                            borderRadius:
                                                                BorderRadius
                                                                    .circular(
                                                                        40),
                                                            borderSide: BorderSide(
                                                                color: Color(
                                                                    0xffEAEBED))),
                                                      ),
                                                      // onTap: () {
                                                      //   readOnly = !readOnly;
                                                      //   setState(() {});
                                                      // },

                                                      // initialValue:
                                                      //     searchController.text,

                                                      onChanged: (text) {
                                                        if (text.isNotEmpty) {
                                                          searchList.clear();
                                                          for (int i = 0;
                                                              i <
                                                                  dataPois
                                                                      .length;
                                                              i++) {
                                                            Datum d =
                                                                dataPois[i];

                                                            if (d.category
                                                                    .toString()
                                                                    .toLowerCase()
                                                                    .contains(
                                                                        text) ||
                                                                d.subcategory
                                                                    .toString()
                                                                    .toLowerCase()
                                                                    .contains(
                                                                        text) ||
                                                                d.poiMultilingual!
                                                                    .en!.name
                                                                    .toString()
                                                                    .toLowerCase()
                                                                    .contains(
                                                                        text)) {
                                                              searchList.add(d);
                                                            }
                                                          }

                                                          setState(() {});
                                                        } else {
                                                          searchList.clear();
                                                          setState(() {});
                                                        }
                                                      },
                                                    ),
                                                  ),
                                                  Stack(
                                                    children: [
                                                      Column(
                                                        mainAxisSize:
                                                            MainAxisSize.min,
                                                        children: [
                                                          const SizedBox(
                                                              height: 10),
                                                          SizedBox(
                                                            child:
                                                                SingleChildScrollView(
                                                              padding: const EdgeInsets
                                                                      .symmetric(
                                                                  horizontal:
                                                                      20),
                                                              child: Column(
                                                                mainAxisAlignment:
                                                                    MainAxisAlignment
                                                                        .start,
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: [
                                                                  // SizedBox(height: 5),
                                                                  Text(
                                                                    "Explore",
                                                                    style: TextStyle(
                                                                        fontSize:
                                                                            fontSize,
                                                                        fontStyle:
                                                                            FontStyle.italic),
                                                                  ),
                                                                  const SizedBox(
                                                                      height:
                                                                          15),
                                                                  Row(
                                                                      mainAxisAlignment:
                                                                          MainAxisAlignment
                                                                              .spaceAround,
                                                                      children: [
                                                                        Column(
                                                                          mainAxisAlignment:
                                                                              MainAxisAlignment.start,
                                                                          crossAxisAlignment:
                                                                              CrossAxisAlignment.start,
                                                                          children: [
                                                                            GestureDetector(
                                                                              onTap: () {
                                                                                // setState(() {
                                                                                //   searchController.text = "Restaurants";
                                                                                // });
                                                                              },
                                                                              child: GestureDetector(
                                                                                onTap: () {
                                                                                  Navigator.push(
                                                                                    context,
                                                                                    MaterialPageRoute(
                                                                                        builder: (context) => const FilterData(
                                                                                              searchData: 'restaurant',
                                                                                            )),
                                                                                  );
                                                                                },
                                                                                child: Row(
                                                                                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                                                                  children: [
                                                                                    Image.asset(
                                                                                      // "assets/symbols/Oval.png",
                                                                                      "assets/images/restro2.png",
                                                                                      // "assets/symbols/neww.png",
                                                                                      height: 30,
                                                                                      width: 30,
                                                                                    ),
                                                                                    const SizedBox(width: 10),
                                                                                    Text(
                                                                                      "Restaurants",
                                                                                      style: TextStyle(fontSize: fontSize),
                                                                                    )
                                                                                  ],
                                                                                ),
                                                                              ),
                                                                            ),
                                                                            const SizedBox(
                                                                              height: 15,
                                                                            ),
                                                                            GestureDetector(
                                                                              onTap: () {
                                                                                Navigator.push(
                                                                                  context,
                                                                                  MaterialPageRoute(
                                                                                      builder: (context) => const FilterData(
                                                                                            searchData: 'shopping',
                                                                                          )),
                                                                                );
                                                                              },
                                                                              child: Row(
                                                                                children: [
                                                                                  Image.asset(
                                                                                    "assets/images/shopping.png",
                                                                                    height: 35,
                                                                                    width: 35,
                                                                                  ),
                                                                                  const SizedBox(width: 10),
                                                                                  Text(
                                                                                    "Shopping",
                                                                                    style: TextStyle(fontSize: fontSize),
                                                                                  )
                                                                                ],
                                                                              ),
                                                                            )
                                                                          ],
                                                                        ),
                                                                        Column(
                                                                          crossAxisAlignment:
                                                                              CrossAxisAlignment.start,
                                                                          children: [
                                                                            GestureDetector(
                                                                              onTap: () {
                                                                                Navigator.push(
                                                                                  context,
                                                                                  MaterialPageRoute(
                                                                                      builder: (context) => const FilterData(
                                                                                            searchData: 'service',
                                                                                          )),
                                                                                );
                                                                              },
                                                                              child: Row(
                                                                                children: [
                                                                                  Image.asset(
                                                                                    "assets/images/facilities.png",
                                                                                    height: 35,
                                                                                    width: 35,
                                                                                  ),
                                                                                  const SizedBox(width: 10),
                                                                                  Text(
                                                                                    "Facilities",
                                                                                    style: TextStyle(fontSize: fontSize),
                                                                                  )
                                                                                ],
                                                                              ),
                                                                            ),
                                                                            const SizedBox(
                                                                              height: 15,
                                                                            ),
                                                                            GestureDetector(
                                                                              onTap: () {
                                                                                Navigator.push(
                                                                                  context,
                                                                                  MaterialPageRoute(
                                                                                      builder: (context) => const FilterData(
                                                                                            searchData: 'utilities',
                                                                                          )),
                                                                                );
                                                                              },
                                                                              child: Row(
                                                                                children: [
                                                                                  Image.asset(
                                                                                    "assets/images/utilities.png",
                                                                                    height: 35,
                                                                                    width: 35,
                                                                                  ),
                                                                                  const SizedBox(width: 10),
                                                                                  Text(
                                                                                    "Utilities",
                                                                                    style: TextStyle(fontSize: fontSize),
                                                                                  )
                                                                                ],
                                                                              ),
                                                                            )
                                                                          ],
                                                                        )
                                                                      ]),
                                                                  const SizedBox(
                                                                    height: 20,
                                                                  ),
                                                                  Text(
                                                                    "Recent Searches",
                                                                    style: TextStyle(
                                                                        fontSize:
                                                                            fontSize,
                                                                        fontStyle:
                                                                            FontStyle.italic),
                                                                  ),
                                                                  const SizedBox(
                                                                    height: 10,
                                                                  ),
                                                                  SizedBox(
                                                                    height: 500,
                                                                    child: ListView
                                                                        .builder(
                                                                      itemCount:
                                                                          recentSearchName
                                                                              .length,
                                                                      itemBuilder:
                                                                          (context,
                                                                              index) {
                                                                        return Column(
                                                                          children: [
                                                                            GestureDetector(
                                                                              onTap: () {
                                                                                Navigator.push(
                                                                                  context,
                                                                                  MaterialPageRoute(builder: (context) => PoiInfo(geo: recentSearchGeo[index], poiName: recentSearchName[index], iconImage: "assets/images/restro2.png")),
                                                                                );
                                                                              },
                                                                              child: searchItem(fontSize, recentSearchName[index], ""),
                                                                            ),
                                                                            const SizedBox(
                                                                              height: 15,
                                                                            ),
                                                                          ],
                                                                        );
                                                                      },
                                                                    ),
                                                                  ),
                                                                  // searchItem(
                                                                  //     fontSize,
                                                                  //     "Baker Street",
                                                                  //     "Level 4, Security Hold Area"),
                                                                  // const SizedBox(
                                                                  //   height: 15,
                                                                  // ),
                                                                  // searchItem(
                                                                  //     fontSize,
                                                                  //     "Baker Street",
                                                                  //     "Level 4, Security Hold Area"),

                                                                  // const SizedBox(
                                                                  //   height: 15,
                                                                  // ),
                                                                  // searchItem(
                                                                  //     fontSize,
                                                                  //     "Baker Street",
                                                                  //     "Level 4, Security Hold Area"),
                                                                  // const SizedBox(
                                                                  //   height: 15,
                                                                  // ),
                                                                  // searchItem(
                                                                  //     fontSize,
                                                                  //     "Baker Street",
                                                                  //     "Level 4, Security Hold Area"),
                                                                  // const SizedBox(
                                                                  //   height: 15,
                                                                  // ),
                                                                  // searchItem(
                                                                  //     fontSize,
                                                                  //     "Baker Street",
                                                                  //     "Level 4, Security Hold Area"),
                                                                  // const SizedBox(
                                                                  //   height: 15,
                                                                  // ),
                                                                  // searchItem(
                                                                  //     fontSize,
                                                                  //     "Baker Street",
                                                                  //     "Level 4, Security Hold Area"),
                                                                  // const SizedBox(
                                                                  //   height: 15,
                                                                  // ),
                                                                  // searchItem(
                                                                  //     fontSize,
                                                                  //     "Baker Street",
                                                                  //     "Level 4, Security Hold Area"),
                                                                  const SizedBox(
                                                                    height: 15,
                                                                  ),
                                                                ],
                                                              ),
                                                            ),
                                                          ),
                                                        ],
                                                      ),
                                                      (searchList != null &&
                                                              searchList
                                                                  .isNotEmpty)
                                                          ? Container(
                                                              // height: double.minPositive,
                                                              height:
                                                                  height * 0.87,
                                                              color:
                                                                  Colors.white,
                                                              child: ListView
                                                                  .builder(
                                                                      itemCount:
                                                                          searchList
                                                                              .length,
                                                                      itemBuilder:
                                                                          (BuildContext context,
                                                                              int index) {
                                                                        return Container(
                                                                          padding: EdgeInsets.symmetric(
                                                                              vertical: 8,
                                                                              horizontal: 10),
                                                                          child:
                                                                              Column(
                                                                            children: [
                                                                              GestureDetector(
                                                                                onTap: () {
                                                                                  recentSearchName.add(searchList[index].poiMultilingual!.en!.name.toString());
                                                                                  recentSearchGeo.add("LatLng(${searchList[index].lat.toString()},${searchList[index].lng.toString()})");
                                                                                  showModalBottomSheet<void>(
                                                                                    isDismissible: true,
                                                                                    enableDrag: true,
                                                                                    context: context,
                                                                                    builder: (BuildContext context) {
                                                                                      return PoiInfo(
                                                                                        geo: "LatLng(${searchList[index].lat.toString()},${searchList[index].lng.toString()})",
                                                                                        poiName: searchList[index].poiMultilingual!.en!.name.toString(),
                                                                                        iconImage: "assets/images/restro2.png",
                                                                                      );
                                                                                    },
                                                                                  );
                                                                                },
                                                                                child: Row(
                                                                                  children: [
                                                                                    const Icon(
                                                                                      Icons.supervised_user_circle,
                                                                                      size: 40,
                                                                                    ),
                                                                                    Padding(
                                                                                      padding: const EdgeInsets.only(left: 12.0),
                                                                                      child: Column(
                                                                                        mainAxisSize: MainAxisSize.min,
                                                                                        crossAxisAlignment: CrossAxisAlignment.start,
                                                                                        children: [
                                                                                          Text(
                                                                                            "${searchList[index].poiMultilingual!.en!.name}",
                                                                                            style: const TextStyle(fontWeight: FontWeight.bold),
                                                                                          ),
                                                                                          Text("${searchList[index].subcategory}")
                                                                                        ],
                                                                                      ),
                                                                                    )
                                                                                  ],
                                                                                ),
                                                                              ),
                                                                              const Divider(
                                                                                thickness: 1,
                                                                              )
                                                                            ],
                                                                          ),
                                                                        );
                                                                      }),
                                                            )
                                                          : Container()
                                                    ],
                                                  ),
                                                ],
                                              );
                                            }));
                                  }),
                            ],
                          ),
                  ),
                ],
              ),
            )),
    );
  }
}

Widget searchItem(fontSize, String propName, String propAddress) {
  return Row(
    mainAxisAlignment: MainAxisAlignment.start,
    children: [
      Image.asset(
        "assets/images/restro2.png",
        height: 30,
        width: 30,
      ),
      const SizedBox(width: 10),
      Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Text(
            propName,
            style: TextStyle(fontSize: fontSize),
          ),
          Text(
            propAddress,
            style: const TextStyle(fontSize: 10),
          )
        ],
      ),
      const SizedBox(
        height: 20,
      )
    ],
  );
}
