import 'package:flutter/material.dart';
import 'package:insuideindoor/main/MyHome.dart';
import 'package:insuideindoor/main/poi_model.dart';
import 'package:insuideindoor/main/services.dart';

class PoiInfo extends StatefulWidget {
  final String geo;
  final String poiName;
  final String iconImage;

  const PoiInfo(
      {Key? key,
      required this.geo,
      required this.poiName,
      required this.iconImage})
      : super(key: key);

  @override
  State<PoiInfo> createState() => _PoiInfoState();
}

class _PoiInfoState extends State<PoiInfo> {
  bool isLoading = true;
  var reqData;

  String? pImage;
  String? pMobile;
  String? pDec;
  String? pTerminal;
  String? pName;
  fetchPois() async {
    GetPoi? poiInfoData = await InternetService().getPOI().then((value) {
      isLoading = false;

      String geoo = widget.geo.toString();
      List first = geoo.split("(");
      List second = first[1].toString().split(",");
      for (int a = 1; a <= loopCounter!; a++) {
        if (value!.data![a - 1].lat.toString().contains(second[0]) &&
            value.data?[a - 1].poiMultilingual?.en?.name == widget.poiName) {
          setState(() {
            pName = value.data?[a - 1].poiMultilingual?.en?.name;
            pTerminal = value.data?[a - 1].terminal;
            pDec = value.data?[a - 1].poiMultilingual!.en!.description;
            pMobile = value.data?[a - 1].mobileNumber;
            pImage = value.data![a - 1].poiUrl;
          });
          print("pImage ${value.data![a - 1].poiUrl}");
          print(
              "FINAL DATA ${reqData = value.data?[a - 1].poiMultilingual?.en?.name}");
        } else {
          continue;
        }
      }
    });
  }

  @override
  void initState() {
    super.initState();
    fetchPois();
  }

  @override
  Widget build(BuildContext context) {
    double width = MediaQuery.of(context).size.width;

    return Scaffold(
      body: SingleChildScrollView(
        child: Padding(
          padding: const EdgeInsets.fromLTRB(8, 0, 8, 8),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.start,
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              const SizedBox(height: 10),
              Align(
                alignment: Alignment.center,
                child: Container(
                  width: width * 0.2,
                  height: 5,
                  decoration: BoxDecoration(
                      color: const Color(0xffEAEBED),
                      borderRadius: BorderRadius.circular(10.0)),
                ),
              ),
              const SizedBox(height: 15),
              // SizedBox(height: MediaQuery.of(context).size.height / ),

              Row(
                mainAxisAlignment: MainAxisAlignment.start,
                children: [
                  CircleAvatar(
                      backgroundColor: Colors.white,
                      radius: 30,
                      backgroundImage: AssetImage(widget.iconImage)),
                  const SizedBox(width: 15),
                  Expanded(
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        Text(
                          pName ?? "Loading",
                          overflow: TextOverflow.visible,
                          softWrap: false,
                          style: const TextStyle(
                              fontWeight: FontWeight.bold, fontSize: 25),
                        ),
                        const SizedBox(height: 5),
                        Row(
                          children: const [
                            Text("Address"),
                            Text(" "),
                            Text("1 km Away")
                          ],
                        ),
                        const SizedBox(height: 5),
                        Text("Terminal $pTerminal")
                      ],
                    ),
                  )
                ],
              ),
              SizedBox(height: 20),
              Container(
                height: 55,
                width: MediaQuery.of(context).size.width - 30,
                decoration: BoxDecoration(
                    color: Colors.white,
                    border: Border.all(color: Colors.black),
                    borderRadius: BorderRadius.all(Radius.circular(50))),
                child: GestureDetector(
                  onTap: () {},
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      const Text(
                        "Get Directions",
                        style: TextStyle(color: Colors.black, fontSize: 18),
                      ),
                      const SizedBox(width: 15),
                      Image.asset(
                        "assets/images/location.png",
                        height: 20,
                        width: 20,
                      ),
                    ],
                  ),
                ),
              ),
              const SizedBox(height: 20),

              (pImage == null || pImage == "")
                  ? Container()
                  : ClipRRect(
                      borderRadius: BorderRadius.circular(8.0),
                      child: Image.network(pImage!)),
              const SizedBox(height: 5),
              Text(pDec ?? "Loading"),
              const SizedBox(height: 5),

              const Text(
                "Information",
                style: TextStyle(fontSize: 17, fontStyle: FontStyle.italic),
              ),
              const SizedBox(height: 20),
              Row(
                children: [
                  const Icon(Icons.phone_outlined),
                  Text(pMobile ?? "No Number")
                ],
              ),
              const SizedBox(height: 20),
              Row(
                children: const [
                  Icon(Icons.watch_later_outlined),
                  Text("5 AM -10 PM")
                ],
              ),
            ],
          ),
        ),
      ),
    );
  }
}
