import 'package:flutter/material.dart';
import 'package:insuideindoor/main/MyHome.dart';
import 'package:insuideindoor/main/filter_data.dart';
import 'package:insuideindoor/main/poiInfo.dart';
import 'package:insuideindoor/main/poi_model.dart';

class ToDirection extends StatefulWidget {
  const ToDirection({Key? key}) : super(key: key);

  @override
  State<ToDirection> createState() => _ToDirectionState();
}

class _ToDirectionState extends State<ToDirection> {
  @override
  Widget build(BuildContext context) {
    double width = MediaQuery.of(context).size.width;
    double height = MediaQuery.of(context).size.height;
    double btnPadding = 10.0;
    double btnSize = 25.0;
    double fontSize = 16.0;
    return Scaffold(
        body:
            //  DraggableScrollableSheet(
            //     initialChildSize: 1,
            //     minChildSize: 0.1,
            //     maxChildSize: 1,
            //     snap: true,
            //     snapSizes: [0.387, 1],
            //     builder: (BuildContext context, scrollSheetController) {
            //       return
            Container(
                decoration: const BoxDecoration(
                    color: Colors.white,
                    borderRadius: BorderRadius.all(Radius.circular(16.0))),
                child: ListView.builder(
                    padding: EdgeInsets.zero,
                    physics: const ClampingScrollPhysics(),
                    // physics: ClampingScrollPhysics(),
                    // controller: scrollSheetController,
                    itemCount: 1,
                    itemBuilder: (BuildContext context, int index) {
                      return Column(
                        children: [
                          const SizedBox(height: 8),
                          Container(
                            width: width * 0.2,
                            height: 5,
                            decoration: BoxDecoration(
                                color: Color(0xffEAEBED),
                                borderRadius: BorderRadius.circular(10.0)),
                          ),
                          const SizedBox(height: 15),
                          Container(
                            margin: const EdgeInsets.symmetric(horizontal: 20),
                            padding: const EdgeInsets.symmetric(vertical: 0),
                            decoration: BoxDecoration(
                                color: Color(0xffEAEBED),
                                borderRadius: BorderRadius.circular(40)),
                            child: Column(
                              children: [
                                //FROM
                                TextFormField(
                                  scrollPadding: EdgeInsets.zero,
                                  decoration: InputDecoration(
                                    isDense: true,
                                    contentPadding: const EdgeInsets.all(0.0),
                                    prefixIcon: Icon(Icons.circle_outlined,
                                        size: btnSize,
                                        color: Color(0xFF555555)),
                                    hintText: "From",
                                    hintStyle: const TextStyle(
                                        fontWeight: FontWeight.bold,
                                        fontSize: 15),
                                    border: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED))),
                                    disabledBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED))),
                                    enabledBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED))),
                                    focusedBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED))),
                                  ),
                                  onChanged: (text) {
                                    if (text.isNotEmpty) {
                                      searchList.clear();
                                      for (int i = 0;
                                          i < dataPois.length;
                                          i++) {
                                        Datum d = dataPois[i];

                                        if (d.category
                                                .toString()
                                                .toLowerCase()
                                                .contains(text) ||
                                            d.subcategory
                                                .toString()
                                                .toLowerCase()
                                                .contains(text)) {
                                          searchList.add(d);
                                        }
                                      }

                                      setState(() {});
                                    }
                                  },
                                ),
                                Container(
                                  color: Colors.white,
                                  height: 20,
                                ),
                                //TO
                                TextFormField(
                                  scrollPadding: EdgeInsets.zero,
                                  decoration: InputDecoration(
                                    // fillColor: Color(0xffEAEBED),
                                    isDense: true,
                                    contentPadding: const EdgeInsets.all(0.0),
                                    prefixIcon: Icon(Icons.location_pin,
                                        size: btnSize,
                                        color: Color(0xFF555555)),

                                    hintText: "To",
                                    hintStyle: const TextStyle(
                                        fontWeight: FontWeight.bold,
                                        fontSize: 15),
                                    border: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED))),
                                    disabledBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED))),
                                    enabledBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED))),
                                    focusedBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED))),
                                  ),
                                  // onTap: () {
                                  //   readOnly = !readOnly;
                                  //   setState(() {});
                                  // },

                                  // initialValue:
                                  //     searchController.text,
                                  onChanged: (text) {
                                    if (text.isNotEmpty) {
                                      searchList.clear();
                                      for (int i = 0;
                                          i < dataPois.length;
                                          i++) {
                                        Datum d = dataPois[i];

                                        if (d.category
                                                .toString()
                                                .toLowerCase()
                                                .contains(text) ||
                                            d.subcategory
                                                .toString()
                                                .toLowerCase()
                                                .contains(text)) {
                                          searchList.add(d);
                                        }
                                      }
                                      // searchList = dataPois
                                      //     .where((element) =>
                                      //         element.category
                                      //             .toString()
                                      //             .toLowerCase()
                                      //             .contains(text) ||
                                      //         element.subcategory
                                      //             .toString()
                                      //             .toLowerCase()
                                      //             .contains(text))
                                      //     .toList();
                                      setState(() {});
                                    }
                                  },
                                  // autofocus: true,
                                  // readOnly: readOnly,
                                ),
                              ],
                            ),
                          ),
                          Stack(
                            children: [
                              Column(
                                mainAxisSize: MainAxisSize.min,
                                children: [
                                  const SizedBox(height: 10),
                                  SizedBox(
                                    child: SingleChildScrollView(
                                      padding: const EdgeInsets.symmetric(
                                          horizontal: 20),
                                      child: Column(
                                        mainAxisAlignment:
                                            MainAxisAlignment.start,
                                        crossAxisAlignment:
                                            CrossAxisAlignment.start,
                                        children: [
                                          Text(
                                            "Explore",
                                            style: TextStyle(
                                                fontSize: fontSize,
                                                fontStyle: FontStyle.italic),
                                          ),
                                          const SizedBox(height: 15),
                                          Row(
                                              mainAxisAlignment:
                                                  MainAxisAlignment.spaceAround,
                                              children: [
                                                Column(
                                                  mainAxisAlignment:
                                                      MainAxisAlignment.start,
                                                  crossAxisAlignment:
                                                      CrossAxisAlignment.start,
                                                  children: [
                                                    GestureDetector(
                                                      onTap: () {},
                                                      child: GestureDetector(
                                                        onTap: () {
                                                          Navigator.push(
                                                            context,
                                                            MaterialPageRoute(
                                                                builder:
                                                                    (context) =>
                                                                        const FilterData(
                                                                          searchData:
                                                                              'restaurant',
                                                                        )),
                                                          );
                                                        },
                                                        child: Row(
                                                          mainAxisAlignment:
                                                              MainAxisAlignment
                                                                  .spaceBetween,
                                                          children: [
                                                            Image.asset(
                                                              // "assets/symbols/Oval.png",
                                                              "assets/images/restro2.png",
                                                              // "assets/symbols/neww.png",
                                                              height: 30,
                                                              width: 30,
                                                            ),
                                                            const SizedBox(
                                                                width: 10),
                                                            Text(
                                                              "Restaurants",
                                                              style: TextStyle(
                                                                  fontSize:
                                                                      fontSize),
                                                            )
                                                          ],
                                                        ),
                                                      ),
                                                    ),
                                                    const SizedBox(
                                                      height: 15,
                                                    ),
                                                    GestureDetector(
                                                      onTap: () {
                                                        Navigator.push(
                                                          context,
                                                          MaterialPageRoute(
                                                              builder: (context) =>
                                                                  const FilterData(
                                                                    searchData:
                                                                        'shopping',
                                                                  )),
                                                        );
                                                      },
                                                      child: Row(
                                                        children: [
                                                          Image.asset(
                                                            "assets/images/shopping.png",
                                                            height: 35,
                                                            width: 35,
                                                          ),
                                                          const SizedBox(
                                                              width: 10),
                                                          Text(
                                                            "Shopping",
                                                            style: TextStyle(
                                                                fontSize:
                                                                    fontSize),
                                                          )
                                                        ],
                                                      ),
                                                    )
                                                  ],
                                                ),
                                                Column(
                                                  crossAxisAlignment:
                                                      CrossAxisAlignment.start,
                                                  children: [
                                                    GestureDetector(
                                                      onTap: () {
                                                        Navigator.push(
                                                          context,
                                                          MaterialPageRoute(
                                                              builder: (context) =>
                                                                  const FilterData(
                                                                    searchData:
                                                                        'facilities',
                                                                  )),
                                                        );
                                                      },
                                                      child: Row(
                                                        children: [
                                                          Image.asset(
                                                            "assets/images/facilities.png",
                                                            height: 35,
                                                            width: 35,
                                                          ),
                                                          const SizedBox(
                                                              width: 10),
                                                          Text(
                                                            "Facilities",
                                                            style: TextStyle(
                                                                fontSize:
                                                                    fontSize),
                                                          )
                                                        ],
                                                      ),
                                                    ),
                                                    const SizedBox(
                                                      height: 15,
                                                    ),
                                                    GestureDetector(
                                                      onTap: () {
                                                        Navigator.push(
                                                          context,
                                                          MaterialPageRoute(
                                                              builder: (context) =>
                                                                  const FilterData(
                                                                    searchData:
                                                                        'utilities',
                                                                  )),
                                                        );
                                                      },
                                                      child: Row(
                                                        children: [
                                                          Image.asset(
                                                            "assets/images/utilities.png",
                                                            height: 35,
                                                            width: 35,
                                                          ),
                                                          const SizedBox(
                                                              width: 10),
                                                          Text(
                                                            "Utilities",
                                                            style: TextStyle(
                                                                fontSize:
                                                                    fontSize),
                                                          )
                                                        ],
                                                      ),
                                                    )
                                                  ],
                                                )
                                              ]),
                                          const SizedBox(
                                            height: 20,
                                          ),
                                          Text(
                                            "Recent Searches",
                                            style: TextStyle(
                                                fontSize: fontSize,
                                                fontStyle: FontStyle.italic),
                                          ),
                                          const SizedBox(
                                            height: 40,
                                          ),
                                          searchItem(fontSize, "Baker Street",
                                              "Level 4, Security Hold Area"),
                                          const SizedBox(
                                            height: 15,
                                          ),
                                          searchItem(fontSize, "Baker Street",
                                              "Level 4, Security Hold Area"),
                                          const SizedBox(
                                            height: 15,
                                          ),
                                          searchItem(fontSize, "Baker Street",
                                              "Level 4, Security Hold Area"),
                                          const SizedBox(
                                            height: 15,
                                          ),
                                          searchItem(fontSize, "Baker Street",
                                              "Level 4, Security Hold Area"),
                                          const SizedBox(
                                            height: 15,
                                          ),
                                          searchItem(fontSize, "Baker Street",
                                              "Level 4, Security Hold Area"),
                                          const SizedBox(
                                            height: 15,
                                          ),
                                          searchItem(fontSize, "Baker Street",
                                              "Level 4, Security Hold Area"),
                                          const SizedBox(
                                            height: 15,
                                          ),
                                          searchItem(fontSize, "Baker Street",
                                              "Level 4, Security Hold Area"),
                                          const SizedBox(
                                            height: 15,
                                          ),
                                        ],
                                      ),
                                    ),
                                  ),
                                ],
                              ),
                              if (searchList != null && searchList.length > 0)
                                Container(
                                  // height: double.minPositive,
                                  height: height * 0.87,
                                  color: Colors.white,
                                  child: GestureDetector(
                                    onTap: () {
                                      Navigator.push(
                                        context,
                                        MaterialPageRoute(
                                            builder: (context) => PoiInfo(
                                                  // geo: argument.options.geometry.toString(),
                                                  geo: searchList[index]
                                                      .lat
                                                      .toString(),
                                                  poiName: searchList[index]
                                                      .poiMultilingual!
                                                      .en!
                                                      .name
                                                      .toString(),
                                                  iconImage:
                                                      "assets/images/restro2.png",
                                                )),
                                      );
                                    },
                                    child: ListView.builder(
                                        itemCount: searchList.length,
                                        itemBuilder:
                                            (BuildContext context, int index) {
                                          return Container(
                                            padding: EdgeInsets.symmetric(
                                                vertical: 8, horizontal: 10),
                                            child: Column(
                                              children: [
                                                Row(
                                                  children: [
                                                    // Image.asset(iconReturn()),
                                                    Icon(
                                                      Icons
                                                          .supervised_user_circle,
                                                      size: 40,
                                                    ),
                                                    Padding(
                                                      padding:
                                                          const EdgeInsets.only(
                                                              left: 12.0),
                                                      child: Column(
                                                        mainAxisSize:
                                                            MainAxisSize.min,
                                                        crossAxisAlignment:
                                                            CrossAxisAlignment
                                                                .start,
                                                        children: [
                                                          Text(
                                                            "${searchList[index].poiMultilingual!.en!.name}",
                                                            style: TextStyle(
                                                                fontWeight:
                                                                    FontWeight
                                                                        .bold),
                                                          ),
                                                          Text(
                                                              "${searchList[index].subcategory}")
                                                        ],
                                                      ),
                                                    )
                                                  ],
                                                ),
                                                Divider(
                                                  thickness: 1,
                                                )
                                              ],
                                            ),
                                          );
                                        }),
                                  ),
                                ),
                            ],
                          ),
                        ],
                      );
                    }))
        // }),
        );
  }
}
